Package: RcppBDT
Type: Package
Title: 'Rcpp' Bindings for the Boost Date_Time Library
Version: 0.2.8
Date: 2026-03-12
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Romain", "Francois", role = "aut",
                    comment = c(ORCID = "0000-0002-2444-4226")))
Description: Access to Boost Date_Time functionality for dates,
 durations (both for days and date time objects), time zones, and 
 posix time ('ptime') is provided by using 'Rcpp modules'. The 
 posix time implementation can support high-resolution of up to 
 nano-second  precision by using 96 bits (instead of 64 with R)
 to present a 'ptime' object (but this needs recompilation with
 a #define set).
License: GPL (>= 2)
LazyLoad: yes
Imports: Rcpp, methods
LinkingTo: Rcpp, BH
URL: https://github.com/eddelbuettel/rcppbdt,
        https://dirk.eddelbuettel.com/code/rcpp.bdt.html
BugReports: https://github.com/eddelbuettel/rcppbdt/issues
RoxygenNote: 6.0.1
NeedsCompilation: yes
Packaged: 2026-03-12 10:24:20 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Romain Francois [aut] (ORCID: <https://orcid.org/0000-0002-2444-4226>)
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-03-12 10:50:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 19:41:28 UTC; unix
Archs: RcppBDT.so.dSYM

import(Rcpp,methods)                    # packages we require

useDynLib(RcppBDT, .registration=TRUE)  # this package's shared library

exportPattern("^[[:alpha:]]+")          # export all identifier (eg the convenience function and consts)
exportMethods("format",                 # all modules have format and show methods defined
              "show")

## RcppBDT: R bindings for Boost Date.Time

[![CI](https://github.com/eddelbuettel/rcppbdt/workflows/ci/badge.svg)](https://github.com/eddelbuettel/rcppbdt/actions?query=workflow%3Aci)
[![License](https://img.shields.io/badge/license-GPL%20%28%3E=%202%29-brightgreen.svg?style=flat)](https://www.r-project.org/Licenses/GPL-2)
[![CRAN](https://www.r-pkg.org/badges/version/RcppBDT)](https://cran.r-project.org/package=RcppBDT)
[![r-universe](https://eddelbuettel.r-universe.dev/badges/rcppbdt)](https://eddelbuettel.r-universe.dev/rcppbdt)
[![Downloads](https://cranlogs.r-pkg.org/badges/RcppBDT?color=brightgreen)](https://www.r-pkg.org/pkg/RcppBDT)
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/rcppbdt)](https://github.com/eddelbuettel/rcppbdt)

### About

This package provides R with access to [Boost
Date_Time](https://www.boost.org/doc/libs/release/doc/html/date_time.html)
functionality by using Rcpp modules.

It is effectively a precursor to the newer and more polished packages [anytime](https://github.com/eddelbuettel/anytime).

### Core Features available via [Boost Date_Time](https://www.boost.org/doc/libs/release/doc/html/date_time.html) 

* [Posix time ("Ptime")](https://www.boost.org/doc/libs/release/doc/html/date_time/posix_time.html): Nano-second precision calculations and datetime calculations
* [Date](https://www.boost.org/doc/libs/release/doc/html/date_time/gregorian.html): basic date calculation support 
* [Date duration](https://www.boost.org/doc/libs/release/doc/html/date_time/gregorian.html#date_time.gregorian.date_duration): Calculations on intervals ("days") 
* [Local time](https://www.boost.org/doc/libs/release/doc/html/date_time/local_time.html): Portable time zone support

Each of these has an individual demo file.

### Status

The package now takes advantage of R 3.1.0 and uses the C++11 standard to get
`long long` support which is needed for high-resolution timing support on all
platforms.

### TODO

All calculations work as implemented, but the package still has a "proof of
concept" flavour as they are not vectorised at the R level. All the relevant operators
operators would have to be defined. That is mostly tedious which is one of
the reasons I have not gotten around to it yet.  Get in touch if you are
interested.


### License

GPL (>= 2)

## Possible Issue

See
[this Stackoverflow question](http://stackoverflow.com/questions/29413175/generating-date-time-zonespec-csv-for-boostdate-time-from-ianas-time-zone-dat)
for problems with this csv file, and the following quote

> Why don't you use Boost.DateTime time zone support?
>
> Boost.DateTime's time zone support is broken. Time zones can not be
> represented with a simple table of rules where daylight saving depend only on
> certain n'th day of week in month. The daylight savings time may vary by
> year, political issues and many other things.

attributed to the
[Boost locale](https://www.boost.org/doc/libs/release/libs/locale/doc/html/dates_times_timezones.html)
documentation.

#!/usr/bin/r

library(RcppBDT)

## parsing character
s <- c("2004-03-21 12:45:33.123456789", # ISO
       "2004-Mar-21 12:45:33.123456789",# also support month abbreviation or full
       "2004-March-21 12:45:33.123456789",
       "2004/03/21 12:45:33.123456789",
       "20040321 124533.123456789",
       "03/21/2004 12:45:33.123456789", # US placing month first (ewwwww....)
       "03-21-2004 12:45:33.123456789",
       "21.03.2004 12:45:33.123456789", # Germany having day.month.year
       "2004-03-21",                    # just dates work fine as well
       "20040321",
       "rapunzel")                      # will produce a NA

p <- toPOSIXct(s)

options("digits.secs"=6)                # make sure we see microseconds in output
print(p)
print(format(p, tz="UTC"))              # format UTC times as UTC (helps for Date types too)

## parsing integer types
s <- c(20150315L, 20010101L, 20141231L)
p <- toPOSIXct(s)
print(format(p, tz="UTC"))

## parsing numeric types
s <- c(20150315, 20010101, 20141231)
print(format(p, tz="UTC"))
print(p)

## and also 'parsing' (ie converting) POSIXct second since epoch (also numeric)
s <- as.numeric(as.POSIXct(Sys.time())) + c(-120,0,120)
p <- toPOSIXct(s)
print(p)

library(microbenchmark)

library(fasttime)
#library(parsedate)
library(RcppBDT)


set.seed(42)

nobs <- 10000
startTime <- as.POSIXct("2015-01-01 00:00:00", tz="UTC")
pt <- startTime + (0:nobs)*1

v <- format(pt, tz="UTC")

base   <- function(x) as.POSIXct(strptime(x, format="%Y-%m-%d %H:%M:%S", tz="UTC"))
ftime  <- function(x) fastPOSIXct(x) #, tz="UTC")
#parset <- function(x) parse_date(x)

rbase  <- base(v)
rftime <- ftime(v)
#rparse <- parset(v)
rbdt   <- toPOSIXct(v)
cbdt   <- charToPOSIXct(v)
#cbdtns   <- charToPOSIXctNS(v)
ccbdt <- cToPOSIXct(v)
all.equal(rbase, rftime, rbdt, cbdt, rcppbdt)

res <- microbenchmark(base(v), ftime(v), #parset(v),
                      toPOSIXct(v), charToPOSIXct(v), #charToPOSIXctNS(v),
                      cToPOSIXct(v),
                      times=100)
print(res)

demo.RcppBDTtz  <- function() {

    require(utils, quiet=TRUE, warn=FALSE)
    require(Rcpp, quiet=TRUE, warn=FALSE)
    require(RcppBDT, quiet=TRUE, warn=FALSE)

    tz <- new(bdtTz, "America/Chicago")

    # format() as cat() enforces txt
    cat("tz object initialized as:       ", format(tz), "\n")
    cat("zone std and dst abbreviation:  ", tz$getStdZoneAbbrev(), "and", tz$getDstZoneAbbrev(), "\n")
    cat("zone std and dst names:         ", tz$getStdZoneName(), "and", tz$getDstZoneName(), "\n")

    cat("\n")
    # format() as cat() enforces txt
    cat("2012 year dst start:            ", format(tz$getDstLocalStart(2012)), "\n")
    cat("2012 year dst end:              ", format(tz$getDstLocalEnd(2012)), "\n")

    cat("\n")
    cat("Offset to UTC (in seconds):     ", tz$getUtcOffset(), "\n")
    cat("DST offset (in seconds):        ", tz$getDstOffset(), "\n")

    cat("\n")
    cat("Formal POSIX string of region:  ", tz$getPosixString(), "\n")

    cat("\n")
    tz1 <- new(bdtTz, "America/Bogota")
    tz2 <- new(bdtTz, "America/Belize")
    cat("UTC difference between Bogota and Belize:    ", tz1$getUtcOffset() - tz2$getUtcOffset(), "\n")

    tz1 <- new(bdtTz, "Australia/Sydney")
    tz2 <- new(bdtTz, "Asia/Singapore")
    cat("UTC difference between Sidney and Singapore: ", tz1$getUtcOffset() - tz2$getUtcOffset(), "\n")

    tz1 <- new(bdtTz, "Europe/Moscow")
    tz2 <- new(bdtTz, "Europe/Madrid")
    cat("UTC difference between Moscow and Madrid:    ", tz1$getUtcOffset() - tz2$getUtcOffset(), "\n")

    cat("\n")
    cat("First 75 tz regions in database:\n")
    print(head(tz$getAllRegions(), 75))


}

demo.RcppBDTtz()

## demo for duration objects

require(utils, quiet=TRUE, warn=FALSE)
require(Rcpp, quiet=TRUE, warn=FALSE)
require(RcppBDT, quiet=TRUE, warn=FALSE)

## ctor with hour, minute, second, fractional seconds (all as ints)
du <- new(bdtDu, 0, 1, 2, 123456789)
print(du)  ## converts to difftime

dn <- new(bdtDu, 0, 1, -2, 123456789)       # negative int permitted too, make it negative sign for object
print(dn)  ## converts to difftime


today <- Sys.Date()    # base R, provides Date
## TODO  fails:   today + du

now <- Sys.time()       # base R
pt <- new(bdtPt) 	# similar to Sys.time()
## TODO  fails as well now + du, but this works
#print(du$getAddedPosixtime(now), tz="UTC")

du$addSeconds(2.2)
du$addMilliSeconds(3.3)
du$addMicroSeconds(4.4)
du$addNanoSeconds(5.5)
du
#print(du$getAddedPosixtime(now))

print(pt)
print(pt + du)


# add 'du' to something and get a time object ?
# convert posix time (from Boost) to POSIXct ?
# more conversions ?

#print(years(1) + months(2) + days(3))
print(du + hours(2) + minutes(3) + seconds(4) + nanoseconds(42))

## use one of several bdtPt ctors
pt <- new(bdtPt, ISOdatetime(2012,1,1,00,30,0,tz="UTC"))

print(pt + du)
print(du + pt)

print(pt + hours(3) + minutes(4))

## demo for time objects

require(utils, quiet=TRUE, warn=FALSE)
require(Rcpp, quiet=TRUE, warn=FALSE)
require(RcppBDT, quiet=TRUE, warn=FALSE)

op <- options("digits.secs"=6)          # to make sure R display microseconds

## use one of several bdtPt ctors
pt <- new(bdtPt, ISOdatetime(2012,1,1,00,30,0,tz="UTC"))

du <- new(bdtDu, 0, 1, 2, 123456789)

print(pt + du)
print(du + pt)

print(pt + hours(3) + minutes(4))
print(pt + 5.5)
print(pt + 5.005)
print(pt + 5.005005)
print(pt + 5.005005005)
print(5.5 + pt)

## Need to make this work too -- second argument is ignored right now
print(pt + c(5.5, 5.5005))

options(op)

## demo for date duration objects

require(utils, quiet=TRUE, warn=FALSE)
require(Rcpp, quiet=TRUE, warn=FALSE)
require(RcppBDT, quiet=TRUE, warn=FALSE)

cat("\n(1) Create a bdtDd object and print it -- as a difftime()\n")
dd <- new(bdtDd, 5)
print(dd)  ## converts to difftime

cat("\n(2) Simple arithmetic, adding btdDd object and adding/subtracing integers\n")
print(dd + dd)                          # date_duration + date_duration
print(dd + 3)
print(dd - 2)
print(2L + dd)
print(2 + dd)
try(print(2 - dd))				# not permitted, bails inside the method -- should we test for ops?

cat("\n(3) Creating a bdtDt date object and adding the bdtDd object\n")
dt <- new(bdtDt, 2012, 10, 10)
print(dt)
print(dd + dt)
print(dt + dd)
print(dt - dd)

cat("\n(4) Adding to the bdtDt date object\n")
print(dt + dd + days(3) + weeks(2))
print(dt)
dt$addMonths(2)
dt$addYears(1)
print(dt)

## no converter from Date yet:  today <- Sys.Date()    # base R, provides Date
##print(today + dd)

demo.RcppBDT  <- function() {

    require(RcppBDT, quiet=TRUE, warn=FALSE)

    ## this uses the pretty-printing the Rcpp module logic to show all
    ## available functions and their docstring (symbol is not exported)
    ##
    ## print(bdtMod$date)

    ## we use a base object 'bdt' for the functions below
    ## by using the instance stored in the environment
    ##
    ## alternatively could construct a new instance from bdtMod$date, see R/zzz.R

    cat("Demo of setters\n");
    ## conversions from string commented out, see inst/include/RcppBDT.h for details
    ##bdt$fromString("2010-10-02"); 	cat("From 2010-10-02   : ", format(bdt), "\n")
    ##bdt$fromUndelString("20101003");  cat("From 20101003     : ", format(bdt), "\n")
    bdt$setFromUTC(); 			cat("From curr. UTC    : ", format(bdt), "\n")
    bdt$setFromLocalClock();		cat("From curr. local  : ", format(bdt), "\n")
    bdt$setEndOfMonth(); 		cat("end of month      : ", format(bdt), "\n")
    bdt$setFirstOfNextMonth(); 		cat("1st of next Month : ", format(bdt), "\n")
    bdt$addDays(4);                     cat("plus four days    : ", format(bdt), "\n")
    bdt$subtractDays(3);                cat("minus three days  : ", format(bdt), "\n")

    bdt$setIMMDate(12, 2010); 		cat("IMM Date Dec 2010 : ", format(bdt), "\n")
    bdt$setEndOfBizWeek();  		cat("end of biz week   : ", format(bdt), "\n")

    cat("\nDemo of getters\n")
    ## now just functions that return values to R
    cat("From curr. local  : ", format(bdt$getLocalClock()), "\n")
    bdt$setFromLocalClock();
    cat("end of biz week   : ", format(bdt$getEndOfBizWeek()), "\n")
    cat("end of of month   : ", format(bdt$getEndOfMonth()), "\n")
    cat("1st of next month : ", format(bdt$getFirstOfNextMonth()), "\n")

    cat("\nDemo of functions\n")
    cat("IMM Date Dec 2010 : ", format(getIMMDate(Dec, 2010)), "\n")
    cat("3rd Wed Dec 2010  : ", format(getNthDayOfWeek(third, Wed, Dec, 2010)), "\n")
    cat("Last Sat Dec 2010 : ", format(getLastDayOfWeekInMonth(Sat, Dec, 2010)), "\n")
    cat("First Sat Dec 2010: ", format(getFirstDayOfWeekInMonth(Sat, Dec, 2010)), "\n")
    cat("First Wed in 2011 : ", format(getFirstDayOfWeekAfter(Wed, as.Date("2010-12-31"))), "\n")
    cat("Last Wed in 2010  : ", format(getLastDayOfWeekBefore(Wed, as.Date("2010-12-31"))), "\n")
}

demo.RcppBDT()
